(ns com-jakewindle-git.scraper
  (:gen-class)
  (:require [clj-http.client :as client]
            [hickory.core :as hick]))

;; Models

;; Page
(defn page [html]
  {:html html :parsed nil})

(defn get-src [uri]
  (:body (client/get uri)))

(defn parse-src [src]
  (hick/parse src))

(defn new-page [uri]
  (-> uri
      (get-src)
      (parse-src)
      (page)))

;; Entities
(defn greet
  "Callable entry point to the application."
  [data]
  (println (str "Hello, " (or (:name data) "World") "!")))

(defn -main
  "I don't do a whole lot ... yet."
  [& args]
  (greet {:name (first args)}))
